from mayordomo import log, pre_process, enviaCorreos
import daemon
import time
import signal
import asyncio

def main():

	async def main_loop():
		await log.info('Demonio iniciado')
		doki = int(time.time()) + 60
		while True:
			if 	await pre_process():
				await enviaCorreos()
			await asyncio.sleep(10)
			i = int(time.time())
			if i >= doki:
				doki = i + 60
				await log.info('Heartbeat')
	
	def run():
		signal.signal(signal.SIGTERM, programCleanup)
		asyncio.run(main_loop())
						
	def programCleanup():
		pass
	
	run()
		
if __name__ == '__main__':
	main()
	